//
// Copyright (c) 2009 Froduald Kabanza and the Université de Sherbrooke.
// Use of this software is permitted for non-commercial research purposes, and
// it may be copied or applied only for that use. All copies must include this
// copyright message.
// 
// This is a research prototype that has not gone through intensive tests and
// is delivered as is. It may still contain bugs. Froduald Kabanza and the
// Université de Sherbrooke disclaim any responsibility for damage that may be
// caused by using it.
//
// Please note that some files were inspired in part by the PDDL4J library:
// http://www.math-info.univ-paris5.fr/~pellier/software/software.php 
//
// Implementation: Simon Chamberland
// Project Manager: Froduald Kabanza
//

#include "stdafx.h"
#include "ObjectParameterVariable.h"
#include "../Bindings.h"
#include "Object.h"

using namespace planning;

ObjectParameterVariable::ObjectParameterVariable(const std::string& name, Type* type)
  : m_name(name), m_type(type)
{
  assert(m_type != NULL);
  _setHashCode(_calculateHashCode());
}

const Type* ObjectParameterVariable::getType() const
{
  return m_type;
}

void ObjectParameterVariable::_output(std::ostream& out) const
{
  out << "?" << m_name;
}

const IExp* ObjectParameterVariable::_internalApply(const Bindings* bindings) const
{
  const Object* value;
  if (bindings->tryGetBinding(this, value))
  {
    return value;
  }
  else
  {
    return this;
  }
}

const Object* ObjectParameterVariable::evaluate(const IClosedWorld* world, const Bindings* bindings) const
{
  return bindings->getBinding(this);
}

int ObjectParameterVariable::_internalCompareTo(const IExp& other) const
{
  COMPARE_PTR(this, &other);

  return 0;
}

